"use strict";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _wrapNativeSuper(Class) { var _cache = typeof Map === "function" ? new Map() : undefined; _wrapNativeSuper = function _wrapNativeSuper(Class) { if (Class === null || !_isNativeFunction(Class)) return Class; if (typeof Class !== "function") { throw new TypeError("Super expression must either be null or a function"); } if (typeof _cache !== "undefined") { if (_cache.has(Class)) return _cache.get(Class); _cache.set(Class, Wrapper); } function Wrapper() { return _construct(Class, arguments, _getPrototypeOf(this).constructor); } Wrapper.prototype = Object.create(Class.prototype, { constructor: { value: Wrapper, enumerable: false, writable: true, configurable: true } }); return _setPrototypeOf(Wrapper, Class); }; return _wrapNativeSuper(Class); }

function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _isNativeFunction(fn) { return Function.toString.call(fn).indexOf("[native code]") !== -1; }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/**
 * Config options
 * @typedef {Object.<string, *>} Config
 * @property {string} [method = "GET"] - HTTP request method
 * @property {string} [url] - The url
 * @property {Object.<string, string>} [headers = {}] - The request headers
 * @property {Object.<string, *>} [params] - The request query
 * @property {*} [data = null] - The data to be sent
 * @property {number} [maxRedirects = 5] - Maximum redirects before error is thrown
 * @property {boolean} [withCredentials = false] - Whether cross-site Access-Control requests should be made using credentials
 *
 * Regrest response object
 * @typedef {Object.<string, *>} Response
 * @property {number} status - The response status code
 * @property {string} statusText - The response status text
 * @property {Object.<string, string>} headers - The response headers
 * @property {string} text - The response raw text
 * @property {Object} json - The response parsed as JSON
 * @property {Blob|any} arrayBuffer - The response as an Blob on browser or Buffer on Node js
 * @property {Blob} blob - The response as a Blob object
 */
var ENVIRONMENTS = Object.freeze({
  BROWSER: 0,
  NODE: 1,
  UNKNOWN: 2
}); // Detect whether instance is ran in browser or on node js

var ENV = (typeof window === "undefined" ? "undefined" : _typeof(window)) === "object" && _typeof(window.document) === "object" ? ENVIRONMENTS.BROWSER : (typeof module === "undefined" ? "undefined" : _typeof(module)) === "object" && module && _typeof(module.exports) === "object" ? ENVIRONMENTS.NODE : ENVIRONMENTS.UNKNOWN;

var NetworkError = /*#__PURE__*/function (_Error) {
  _inherits(NetworkError, _Error);

  var _super = _createSuper(NetworkError);

  function NetworkError(message, request, response) {
    var _this;

    _classCallCheck(this, NetworkError);

    _this = _super.call(this, message);
    _this.name = _this.constructor.name;
    _this.response = response;
    _this.request = request;

    if (typeof Error.captureStackTrace === "function") {
      Error.captureStackTrace(_assertThisInitialized(_this), _this.constructor);
    } else {
      _this.stack = new Error(message).stack;
    }

    return _this;
  }

  return NetworkError;
}( /*#__PURE__*/_wrapNativeSuper(Error));

function Regrest() {
  switch (ENV) {
    case ENVIRONMENTS.BROWSER:
      this.requestAdapter = xhrAdapter.bind(this);
      break;

    case ENVIRONMENTS.NODE:
      this.nodeAdapters = {
        http: require("follow-redirects").http,
        https: require("follow-redirects").https
      };
      this.requestAdapter = httpAdapter.bind(this);
      break;

    default:
      throw new Error("Unsupported environment");
  }
}
/**
 * @param {Config} config
 * @param {string} config.url - The url
 * @returns {Promise<Response>}
 * @memberof Regrest
 */


Regrest.prototype.request = function (_ref) {
  var _ref$method = _ref.method,
      method = _ref$method === void 0 ? "GET" : _ref$method,
      url = _ref.url,
      _ref$headers = _ref.headers,
      headers = _ref$headers === void 0 ? {} : _ref$headers,
      params = _ref.params,
      _ref$data = _ref.data,
      data = _ref$data === void 0 ? null : _ref$data,
      _ref$maxRedirects = _ref.maxRedirects,
      maxRedirects = _ref$maxRedirects === void 0 ? 5 : _ref$maxRedirects,
      _ref$withCredentials = _ref.withCredentials,
      withCredentials = _ref$withCredentials === void 0 ? false : _ref$withCredentials;
  // Generate query string and join it with url
  url = "".concat(url).concat(params ? "?".concat(Object.entries(params).map(function (_ref2) {
    var _ref3 = _slicedToArray(_ref2, 2),
        key = _ref3[0],
        value = _ref3[1];

    return "".concat(key, "=").concat(value);
  }).join("&")) : "");
  return this.requestAdapter(method, url, data, headers, maxRedirects, withCredentials);
}; // Convenience methods

/**
 * @param {string} url - The url
 * @param {Config} [config] - Config
 * @returns {Promise<Response>}
 * @memberof Regrest
 */


["get", "head", "delete", "options"].forEach(function (method) {
  return Regrest.prototype[method] = function (url, config) {
    return this.request(_objectSpread(_objectSpread({}, config), {}, {
      method: method.toUpperCase(),
      url: url
    }));
  };
});
/**
 * @param {string} url - The url
 * @param {*} [data] - The data to be sent
 * @param {Config} [config] - Config
 * @returns {Promise<Response>}
 * @memberof Regrest
 */

["post", "put", "patch"].forEach(function (method) {
  return Regrest.prototype[method] = function (url, data, config) {
    return this.request(_objectSpread(_objectSpread({}, config), {}, {
      method: method.toUpperCase(),
      url: url,
      data: data
    }));
  };
}); // Export

if ((typeof module === "undefined" ? "undefined" : _typeof(module)) === "object" && module && _typeof(module.exports) === "object") {
  /**
   * Expose Regrest as module.exports in loaders
   * that implement the Node module pattern (including browserify)
   */
  module.exports = new Regrest();
} else {
  // Otherwise expose Regrest to the global object
  window.regrest = new Regrest();
} // Unexposed helper methods and adapters


function xhrAdapter(requestType, url, body, headers, _, withCredentials) {
  return new Promise(function (resolve, reject) {
    var request = new XMLHttpRequest();
    request.open(requestType, url, true);
    Object.entries(headers).forEach(function (_ref4) {
      var _ref5 = _slicedToArray(_ref4, 2),
          key = _ref5[0],
          value = _ref5[1];

      return request.setRequestHeader(key, value);
    });
    withCredentials && (request.withCredentials = true);

    request.onload = function () {
      var contentType = (this.getResponseHeader("Content-Type") || "").split(";")[0].trim();
      var response = {
        status: this.status,
        statusText: this.statusText,
        headers: _objectSpread({}, this.getAllResponseHeaders().trim().split(/[\r\n]+/).map(function (header) {
          return header.split(": ");
        }).reduce(function (obj, _ref6) {
          var _ref7 = _slicedToArray(_ref6, 2),
              key = _ref7[0],
              value = _ref7[1];

          return _objectSpread(_objectSpread({}, obj), {}, _defineProperty({}, key.toLowerCase(), value));
        }, {})),
        text: this.responseText,

        get json() {
          var result = JSON.parse(this.text);
          delete this.json;
          return this.json = result;
        },

        get blob() {
          var result = new Blob([request.response], {
            type: contentType
          });
          delete this.blob;
          return this.blob = result;
        },

        get arrayBuffer() {
          delete this.arrayBuffer;
          return this.arrayBuffer = this.blob;
        }

      };

      if (this.status >= 200 && this.status < 400) {
        resolve(response);
      } else {
        reject(new NetworkError("".concat(this.status, " ").concat(this.statusText), request, response));
      }
    };

    request.onerror = function () {
      reject(new NetworkError("connection error", request));
    };

    request.send(body);
  });
}

function httpAdapter(requestType, url, body, headers, maxRedirects) {
  var _this2 = this;

  return new Promise(function (resolve, reject) {
    var parsedUrl = new URL(url);
    var options = {
      host: parsedUrl.host,
      path: "".concat(parsedUrl.pathname).concat(parsedUrl.search),
      method: requestType,
      headers: headers,
      maxRedirects: maxRedirects
    };

    var req = _this2.nodeAdapters[parsedUrl.protocol.slice(0, -1)].request(options, function (res) {
      var response = {
        status: res.statusCode,
        statusText: res.statusMessage,
        headers: res.headers,
        arrayBuffer: [],

        get text() {
          var result = this.arrayBuffer.toString("utf-8");
          delete this.text;
          return this.text = result;
        },

        get json() {
          var result = JSON.parse(this.text);
          delete this.json;
          return this.json = result;
        },

        get blob() {
          if (Blob === undefined) {
            throw new Error("Please include Blob polyfill for Node.js");
          }

          var contentType = this.headers["content-type"] || "";
          var result = new Blob([new Uint8Array(this.arrayBuffer)], {
            type: contentType.split(";")[0].trim()
          });
          delete this.blob;
          return this.blob = result;
        }

      };
      res.on("data", function (chunk) {
        return response.arrayBuffer.push(chunk);
      });
      res.on("end", function () {
        response.arrayBuffer = Buffer.concat(response.arrayBuffer);

        if (res.statusCode >= 200 && res.statusCode < 400) {
          resolve(response);
        } else {
          reject(new NetworkError("".concat(res.statusCode, " ").concat(res.statusMessage), req, response));
        }
      });
    });

    req.on("error", function (e) {
      return reject(new NetworkError(e.message, req));
    });
    body && req.write(body);
    req.end();
  });
}